whitelist={}

whitelist.ip={}
whitelist.usgn={}
whitelist.nickname={}

canjoin={}
for i=1,32 do
	canjoin[i]=false
end

function addmember(s)
	if (s:sub(1,1)~="#") then
		local nsign=s:find("#")
		msg(nsign)
		s=s:sub(1,nsign-2)
		if (type(tonumber(s))=="number") then
			table.insert(whitelist.usgn,tonumber(s))
		else
			local _=s:gsub("%.","")
			s=_:gsub("%s","")
			if (type(tonumber(s))=="number") then
				table.insert(whitelist.ip,s)
			else
				table.insert(whitelist.nickname,s)
			end
		end
	end
end

function readlist()
	local file=assert(io.open("sys/whitelist.cfg","r"))
	for line in file:lines() do
		if (line:len()>0) then
			addmember(line)
		end
	end
	file:close()
end

function writelist(entry)
	local file=assert(io.open("sys/whitelist.cfg","a+"))
	file:write(entry.."\n")
	file:close()
end

readlist()

addhook("join","checkplayer",10000)
function checkplayer(id)
	for _,v in pairs(whitelist.ip) do
		if player(id,"ip")==v then canjoin[id]=true end
	end
	for _,v in pairs(whitelist.usgn) do
		if player(id,"usgn")==v then canjoin[id]=true end
	end
	for _,v in pairs(whitelist.nickname) do
		if player(id,"name")==v then canjoin[id]=true end
	end
	if not canjoin[id] then
		parse("kick "..id.." \"Only whitelisted players are allowed to join\"")
	end
end

addhook("leave","resetplayer",10000)
function resetplayer(id)
	canjoin[id]=false
end

addhook("parse","editlist",10000)
addhook("rcon","editlist",10000)
function editlist(cmd)
	if (cmd:sub(1,4)=="wadd") then
		local wentry=cmd:sub(6)
		writelist(wentry)
		addmember(wentry)
		print(wentry.." has been added to whitelist")
		return 2
	end
end